/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package multithreading2;

import java.applet.*;


/**
 *
 * @author claudiu
 */
public class AppletParticule extends Applet {
    protected int nrParticule = 13;
    protected Thread[] threads = null;
    protected final DetectorParticule detector = new DetectorParticule(100);
    
    @Override
    public void init() {
        add(detector);
    }
    
    public synchronized void notifica() {
        detector.resetParticule();
        notifyAll();
    }

    public synchronized void elibereazaDetectare() throws InterruptedException {
        int particuleCapturate = detector.checkCaptura();

        if (particuleCapturate >= nrParticule-1) {                     
            Thread.sleep(3000);
            notifica(); 
        }
    }

    public synchronized void asteaptaDetectare() throws InterruptedException{
        wait();
    }
            
    protected Thread generareParticula(final Particula p) {
        Runnable runLoop = new Runnable() {
            // clasa interioara anonima
            
            @Override
            public void run() {
                try {
                    while (true) {
                        int moveType = p.move();
                        switch(moveType) {
                            case 0: 
                                detector.repaint();
                                Thread.sleep(100);
                                break;
                            case 1:
                                detector.repaint();
                                // asteaptaDetectare();
                                Thread.sleep(1000);
                                break;
                            case 2:
                                detector.repaint();
                                asteaptaDetectare();
                                // Thread.currentThread().sleep(6000);
                                break;
                        }
                        
                        elibereazaDetectare();                        
                    }
                } catch (InterruptedException e) {
                    return;
                }
            }
        };
        
        return new Thread(runLoop);
    }
    
    @Override
    public synchronized void start() {
        int n = nrParticule;
        
        if (threads == null) {
            Particula[] particule = new Particula[n];
            
            for (int i = 0; i < n; i++)
                particule[i] = new Particula(50, 50);
            
            detector.setParticule(particule);
            
            threads = new Thread[n];
            for (int i = 0; i < n; i++) {
                threads[i] = generareParticula(particule[i]);
                threads[i].start();
            }
        }
    }
    
    @Override
    public synchronized void stop() {
        if (threads != null) {
            for (int i = 0; i < threads.length; i++)
                threads[i].interrupt();
            threads = null;
        }
    } 
}
