/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package multithreading2;

import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;


/**
 *
 * @author claudiu
 */
public class DetectorParticule extends Canvas {
    private Particula[] particule = new Particula[0];
    
    DetectorParticule(int dim) {
        setSize(new Dimension(dim, dim));
    }
    
    protected synchronized void setParticule(Particula[] ps) {
        if (ps == null)
            throw new IllegalArgumentException("Multimea particuleleor nu poate fi nula");
        
        particule = ps;
    }
    
    public synchronized void resetParticule() {
        Particula[] ps = getParticule();
 
        for (int i = 0; i < ps.length; i++)
            ps[i].setCaptura(false);
    } 
    
    protected synchronized Particula[] getParticule() {
        return particule;
    }
    
    @Override
    public synchronized void paint(Graphics g) {
        Particula[] ps = getParticule();
        
        for (int i = 0; i < ps.length; i++)
            ps[i].draw(g);
    }
    
    public synchronized int checkCaptura() {
        Particula[] ps = getParticule();
        int particuleCapturate = 0;
        
        for (int i = 0; i < ps.length; i++)
            if (ps[i].getCaptura())
                ++particuleCapturate;
        
        return particuleCapturate;
    } 
}
